//
// AUTHOR:  Dangerfreak www.dsk.coolhere.com
//------------------------------------------------------------------------------

$missionName = "DF_Nightmare";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("DF_RemoteLib.cs");

$server::HudMapViewOffsetX = 14900;
$server::HudMapViewOffsetY = 14900;
$irq=0;

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

        // what can the server admin choose for available teams
        $server::disableTeamRed = false;
        $server::disableTeamBlue = true;
        $server::disableTeamYellow = false;
        $server::disableTeamPurple = true;

	$server::TeamDamage = false;

}

function setDefaultMissionItems()
{
	allowComponent(all,True);

// keine sensoren erlaubt

	allowcomponent(400,false);
	allowcomponent(401,false);
	allowcomponent(408,false);
	allowcomponent(409,false);
	allowcomponent(410,false);
	allowcomponent(411,false);
	allowcomponent(412,false);
	allowcomponent(413,false);
	allowcomponent(414,false);
	allowcomponent(426,false);
	allowcomponent(427,false);
	allowcomponent(428,false);
	allowcomponent(429,false);
	allowcomponent(430,false);
	allowcomponent(431,false);
	allowcomponent(432,false);
	allowcomponent(433,false);
	allowcomponent(434,false);

// nur basic computer erlaubt

	allowcomponent(801,false);
	allowcomponent(802,false);
	allowcomponent(806,false);
	allowcomponent(807,false);

	// dreckswaffen verbieten
	noCheapWeapons();
}

function onMissionStart()
{
	stormSounds();
	initenemies();
	if ($irq!=1)
	{
		interrupt();
		$irq=1;
	}
}

function onMissionLoad()
{
   cdAudioCycle("Purge"); 
   %ausgabe1 = "Welcome to the 'Nightmare'! This map is for EXPERTS and DANGERSEEKERS only!\n\n"
	     @ "Fight the AIs (=computer pilots/red team) as a team, "
             @ "in nearly complete darkness - but you don't have sensors "
	     @ "and only a small computer, so lock your target manually - if you see it!!!\n"
	     @ "\n\nHEAR the enemies... FEEL them... SMELL them... KILL THEM!!!"
	     @ "\n\nScan anything to change the difficulty level!\n"
	     @ "PS: What did you say? 'This map sucks'? ROOKIE, YOU suck!\n\n"
             @ $copyright;
   setGameInfo(%ausgabe1);
   %terrain = getObjectId("MissionGroup\\World\\terrain");
   createAmbientSoundSource(%terrain, 0, 15, 30);
   addToAmbientSoundSource(%terrain, "scene1.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene2.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene3.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene4.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene4.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene5.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CA.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CB.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CC.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CD.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CE.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "cin_he2.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "cin_hb3.wav", IDPRF_2D);
}

// ----------------

function initenemies()
{
	$mehr = 2; // AIs = players+mehr 
	$players = 0;
	$enemies = 0;
	$autoheal = true;
	$autoreload = true;
	$basetime = getCurrentTime();
	$resettime = $basetime;	

	$veh[1] = 20;  // seeker
	$veh[2] = 21;  // goad
	$veh[3] = 22;  // shepherd
	$veh[4] = 23;  // judge
	$veh[5] = 24;  // exec
	$veh[6] = 25;  // bolo
	$veh[7] = 26;  // recluse
	$veh[8] = 31;  // avenger
	$veh[9] = 2 ; // minotaur
	$veh[10] = 5;  // basilisk
	$veh[11] = 1; // apoc
	$veh[12] = 3;  // gorgon
	$veh[13] = 30; // eman
	$veh[14] = 33; // oly
	$veh[15] = 41; // predator
	$veh[16] = 32; // dreadlock
	$veh[17] = 7; // myrmidon
	$veh[18] = 6; // paladin
	$veh[19] = 4;  // talon
	// knights
	$veh[20] = 13;  // talon
	$veh[21] = 11;  // minotaur
	$veh[22] = 14; // basilisk
	$veh[23] = 10;  // apoc
	$veh[24] = 12; // gorg
	$veh[25] = 16;  // myrmidon
	$veh[26] = 15; // paladin
	// platinum guard
	$veh[27] = 56; // exec
	$veh[28] = 55; // judge
	// panzerausgleich
        $veh[29] = 32; // dreadlock
	$veh[30] = 25; // bolo
	$veh[31] = 26; // recluse
	$veh[32] = 31; // avenger
	$veh[33] = 41; // pred
	$veh[34] = 29; // prometheus
	$veh[35] = 8; // dis
	$veh[36] = 138; // pouncer assault bike
        $veh[37] = 150; // starsiege magic bus
	$veh[38] = 133; // Nike

	pilot();
	deleteall();
}

//------------------

function pilot()
{
	Pilot RedPilot
	{
	   id = 40;
   
	   name = "AI-Pilot";
   
	   skill = 2.0;
	   accuracy = 2.0;
	   aggressiveness = 2.0;
	   activateDist = 1000.0;
	   deactivateBuff = 1100.0;
	   targetFreq = 0.3;
	   trackFreq = 0.3;
	   fireFreq = 0.4;
	   LOSFreq = 0.4;
	   orderFreq = 1.0;
	};
}

// ------------------

function deleteAll()
{
	for (%i=1; %i<=$objcount; %i++) 
 	{
		if ($objlist[%i] > 0)
		{
			deleteObject($objlist[%i]);
		} 
	}
	$objcount = 0;
	$enemies = 0;
}

//----------------------

function newEnemy() 
{
 	if ($enemies < $players+$mehr && $players>0)
	{
		%vehicleId=getRandomVehicleId();
		if (%vehicleId>8000)
		{
			%obj1 = randomInt(1,38);
			%herctype = $veh[%obj1]; 
			%obj1 = "herc";
			
			if (%herctype>=6 && %herctype<=8) { %obj1 = "tank"; }
			if (%herctype==9) { %obj1 = "flyer"; }
			if (%herctype>=15 && %herctype<=17) { %obj1 = "tank"; }
			if (%herctype>=18 && %herctype<=19) { %obj1 = "flyer"; }
			if (%herctype>=25 && %herctype<=26) { %obj1 = "tank"; }
			if (%herctype>=31 && %herctype<=32) { %obj1 = "tank"; }
			if (%herctype==41) { %obj1 = "tank"; }
			if (%herctype==45) { %obj1 = "tank"; }
			if (%herctype==51) { %obj1 = "tank"; }
			if (%herctype>=60 && %herctype<=70) { %obj1 = "tank"; }
			if (%herctype>=71 && %herctype<=73) { %obj1 = "tank"; }			
			if (%herctype==90) { %obj1 = "tank"; }
			if (%herctype>=91 && %herctype<=96) { %obj1 = "flyer"; }
			if (%herctype>=110 && %herctype<=111) { %obj1 = "flyer"; }
			if (%herctype>=130 && %herctype<=132) { %obj1 = "flyer"; }
			if (%herctype>=133 && %herctype<=150) { %obj1 = "tank"; }
			
			%herc = newObject("Cybrid",%obj1,%herctype);
			setVehicleRadarVisible(%herc,false);
			$objcount++; 
			$objlist[$objcount] = %herc; 
			setTeam(%herc,*IDSTR_TEAM_RED); 
			setPilotId(%herc,40); 
			order(%herc,attack,%vehicleId);
			setRandomPos(%herc,%vehicleId);
			$enemies++;
		}
	}
}

// ----------------------------

function setRandomPos(%cybrid,%target)
{
	%x = getPosition(%target,x);
	%y = getPosition(%target,y);
	%x = %x + randomInt(1,6000) - 3000;
	%y = %y + randomInt(1,6000) - 3000;
	%z = getTerrainHeight(%x,%y);
	setPosition(%cybrid,%x,%y,%z+250);
}

// ----------------------------------------------------------------

function structure::onScan(%scanned,%scanner)
{
	levelhoch();
}

// ----------------

function vehicle::onScan(%scanned,%scanner)
{
	levelhoch();
}

// -----------------

function levelhoch()
{
	if ($autoheal==true)
	{
		$autoheal=false;
	}
	else if ($autoreload==true)
	{
		$autoreload=false;
	}
	else
	{
		$mehr++;
		$autoheal=true;
		$autoreload=true;
	}
	if ($mehr>7)
	{
		$mehr=0;
		$autoheal=true;
		$autoreload=true;
	}
	say(0,1,$player+$mehr @ " AIs, autoheal:" @ $autoheal @ ", autoreload:" @ $autoreload);
}

// ----------------

function player::onAdd(%this)                                                            
{
	antistealth(%this,"in");
	%ausgabe = "Welcome!";
	say(%this,0,%ausgabe);
	messagebox(%this,"IMPORTANT: Check the Game info tab!!!");
}

// ---------------

function vehicle::onAdd(%vehicleId)
{
	%player=playerManager::vehicleIdtoPlayerNum(%vehicleId);
	if (%player>0)
	{
		setTeam(%vehicleId,*IDSTR_TEAM_YELLOW);
		$players++;
		setVehicleSpecialIdentity(%vehicleId,on);
		say(0,1,getHudName(%vehicleId) @ " entered the battlefield.");
	}
}

// -----------------

function vehicle::onDestroyed(%destroyed,%destroyer)
{
	%player = playerManager::vehicleIdToPlayerNum(%destroyed);
	reloadObject(%destroyer,40000);
	say(0,1,getHudName(%destroyer) @ " killed " @ getHudName(%destroyed));
	healObject(%destroyer,70000);
	schedule("healObject(" @ %destroyer @ ",70000);",1);
	schedule("healObject(" @ %destroyer @ ",70000);",2);
	if (%player<=0)
	{
		$enemies--;
		$basetime=getCurrentTime();
		schedule("deleteObject(" @ %destroyed @ ");",10);
	}
	else
	{
		$players--;
	}
}

// ------------------

function getRandomVehicleId()
{
	%vehicleId = 0;
	if ($players>0)
	{
		%number=playerManager::getPlayerCount();
		%random=randomInt(1,%number);
		%player=playerManager::getPlayerNum(%random-1);
		%vehicleId=playerManager::playerNumToVehicleId(%player);
	}
 	return %vehicleId;
}

// ----------------

function interrupt()
{
	schedule("interrupt();",5);
	newenemy();
	if (($basetime+150<getCurrentTime() || $resettime+300<getCurrentTime()) && $players>0)
	{
		resetOrder();
	}
}

// -------------------

function resetOrder()
{
	for (%i=1; %i<=$objcount; %i++) 
 	{
		if ($objlist[%i] > 0)
		{
			%obj=getRandomVehicleId();
			order($objlist[%i],attack,%obj);
		} 
	}
	$basetime=getCurrentTime();
	$resettime=$basetime;
	say(0,1,"AIs (re)activated");
}

// ---------------------

