// target practice, tell player wen he hits a herc
// city_target_Practice
// original by MIB
// improved and debugged: Dangerfreak
$missionName = "City Target Practice";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("DF_RemoteLib.cs");

///////////////////////////////////////////////////////////////////////////////////////////////////
// Lots O' Globals
///////////////////////////////////////////////////////////////////////////////////////////////////
$AIDropPoint = 0;
$redHercDropGroup = "MissionGroup/DropPointGroup3";
$server::TeamDamage = false;

$moreai = 2;

$aiMade = false;
///////////////////////////////////////////////////////////////////////////////////////////////////
// our base defender attributes
//
// The jump from 0.9 to 1.0 is a big one. At skill 1.0 and accuracy 1.0 the AI units will aim 
// first for the weapons, then the legs. A little too much for this mission.
//
///////////////////////////////////////////////////////////////////////////////////////////////////

$minPilot = 30;
$maxPilot = 40;
$currentPilot = 35;

Pilot RedPilot
{
   id = 30;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.5;
   accuracy = 0.5;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.5;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 31;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.5;
   accuracy = 0.6;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.5;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 32;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.6;
   accuracy = 0.6;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.4;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 33;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.7;
   accuracy = 0.6;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.4;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 34;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.7;
   accuracy = 0.7;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.4;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 35;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.7;
   accuracy = 0.8;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.4;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};
Pilot RedPilot
{
   id = 36;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.8;
   accuracy = 0.8;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};

Pilot RedPilot
{
   id = 37;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.9;
   accuracy = 0.8;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.3;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};

Pilot RedPilot
{
   id = 38;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.9;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.2;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};


Pilot RedPilot
{
   id = 39;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 1.0;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.2;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};


Pilot RedPilot
{
   id = 40;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 1.0;
   accuracy = 1.0;
   aggressiveness = 1.0;
   activateDist = 200.0;
   deactivateBuff = 300.0;
   targetFreq = 0.1;
   trackFreq = 0.1;
   fireFreq = 0.1;
   LOSFreq = 0.1;
   orderFreq = 0.1;
};



function initGlobalVars()
{
   $scoringFreeze = false;
   
   %playerCount = playerManager::getPlayerCount();
	// clear all points for the players
   for (%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum(%p);
      %player.numKills = 0;
      %player.buildingsDestroyed = 0;
   }
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = True;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function setDefaultMissionItems()
{
   allowWeapon(   150, FALSE  );      //SMART Gun
}

function onMissionLoad()
{

  $aiMade = false;

  deleteObject( "MissionGroup/yellowHercs" );
  deleteObject( "MissionGroup/redHercs" );

  newObject( "yellowHercs", SimGroup );
  addToSet( "MissionGroup", "yellowHercs" );

  newObject( "redHercs", SimGroup );
  addToSet( "MissionGroup", "redHercs" );

 $redHercGroup = getObjectid ("MissionGroup/redHercs");

$hercPath = getObjectid ("MissionGroup/hercPath");

   %rules = "Target Practice\n"
          @ "Original map by MIB, "
          @ "improved and debugged: "
          @ $copyright;
   setGameInfo(%rules);
}

//-------------------------------------------------------------
function player::onAdd(%this)
{
   say(%this, 0,"Original map by MIB, improved and debugged: " @ $copyright);
   antistealth(%this,"in");
}

//-------------------------------------------------------------
function vehicle::onAdd(%this)
{


   // see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
      return;


   makeAI();

   if (getTeam (%this) != *IDSTR_TEAM_BLUE)
    {
     setTeam(%this, *IDSTR_TEAM_BLUE);
     redrop(%this);
    }

}

//-------------------------------------------------------------
function vehicle::onDestroyed( %this, %destroyer )
{

// say (0, 0, "AI destroyed with "@ %this.hits @ " hits.");

   if( getTeam( %this ) == *IDSTR_TEAM_RED )
   {
      $blueKills++;

      $currentPilot++;
      if ( $currentPilot > $maxPilot) $currentPilot--;
      fullheal(%destroyer);
      say (0,0, "Setting pilot #" @ $currentPilot);
      schedule( "deleteObject(" @ %this @ ");", 5 );
   }
   else
   {
      $redKills++;

      $currentPilot--;
      if ( $currentPilot < $minPilot) $currentPilot++;
      setPilotid (%destroyer, $currentPilot);
      say (0,0, "Setting pilot #" @ $currentPilot);
   }


   schedule ("makeAI();", 7 );

   // award the player a kill ( if the enemy is a different color )
   if( getTeam( %destroyer ) != getTeam( %this ) )
   {
      %player = playerManager::vehicleIdToPlayerNum( %destroyer );
      if(%player != 0)
      {
         %player.numKills++;      
      }
   }
   
   //----------------------------------------------------------------
   // If any of our AI hercs die, give a message and re-clone/drop them
   //----------------------------------------------------------------

   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%this, %destroyer);
   
   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message @ " AI destroyed with "@ %this.hits @ " hits.");
   }

}

//-------------------------------------------------------------
//-------------------------------------------------------------
function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

	$ScoreBoard::PlayerColumnHeader1 = "Team";
	$ScoreBoard::PlayerColumnHeader2 = "Kills";
	$ScoreBoard::PlayerColumnHeader3 = "Buildings Destroyed";

	$ScoreBoard::PlayerColumnFunction1 = "getTeam2";
	$ScoreBoard::PlayerColumnFunction2 = "getKills";
	$ScoreBoard::PlayerColumnFunction3 = "getBuildingsDestroyed";

   $ScoreBoard::TeamColumnHeader1 = "Structures Remaining";
   $ScoreBoard::TeamColumnHeader2 = "Total Kills";
   $ScoreBoard::TeamColumnFunction1 = "getRemainingStructures";
   $ScoreBoard::TeamColumnFunction2 = "getTeamKills";
 
   serverInitScoreBoard();
}

function getTeam2(%player)
{
   if( getTeam( %player ) == *IDSTR_TEAM_BLUE )
   {
      return *IDMULT_BLUE;
   }
   else
   {
      return *IDMULT_RED;
   }
}

function getKills(%player)
{
   if( %player.numKills != "")
      return %player.numKills;
      
   return "0";
}

function getTeamKills(%team)
{
   if( getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE )
   {
      return $blueKills;
   }
   else
   {
      return $redKills;
   }   
}

function getRemainingStructures(%team)
{
   if( getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE )
   {
      return $BUILDINGS_TO_DESTROY - $blueBuildingsDestroyed;
   }
   else
   {
      return $BUILDINGS_TO_DESTROY - $redBuildingsDestroyed;
   }   
}

function getBuildingsDestroyed(%player)
{
   if( %player.buildingsDestroyed != "")
      return %player.buildingsDestroyed;
   
   return "0";
}

//-------------------------------------------------------------
function onMissionStart()
{

	$healRate = 100;   
	$ammoRate = 3;
 	$padWaitTime = 45;

 
   initGlobalVars();
   $hercPath = getObjectid ("MissionGroup/hercPath");

}


// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}
 


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// this function uses more AI, ones like the cinematic apoc, and harabec's apoc, which is really  hard to kill
function getRandomAI()
{



   // check for valid ranges
   %i = RandomInt(1,56);

//say (0,0,"DEBUG: in drop ememy, i=" @ %i );

   if ( %i>8 && %i<10 )
      %i = RandomInt(1,8);
   if ( %i>17 && %i<20 )
      %i = RandomInt(20,29);

   if ( %i == 34  )
      %i = RandomInt(35,45);
   if ( %i>45 && %i<50 )
      %i = RandomInt(50,52);
   if ( %i>52 && %i<55 )
      %i = RandomInt(55,56);

//say (0,0,"DEBUG: in drop ememy, i=" @ %i );

// get appropriate type Tank or Herc
   %type = Herc;
   if ( %i>5  && %i<= 8 )   %type = Tank;
   if ( %i>14 && %i<= 17 )  %type = Tank;
   if ( %i>24 && %i<= 26 )  %type = Tank;
   if ( %i>30 && %i< 33 )  %type = Tank;
   if ( %i == 41 )  %type = Tank;
   if ( %i == 45 )  %type = Tank;
   if ( %i == 51 )  %type = Tank;

   return NewObject("AI " @ %i , %type , %i);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

function getNextDropPoint()
{
  $AIDropPoint = getNextObject ($redHercDropGroup, $AIDropPoint);
  if ($AIDropPoint == 0)
   {
     $AIDropPoint = getNextObject ($redHercDropGroup, $AIDropPoint);
   }
  return $AIDropPoint;
}

//-------------------------------------------------------------
function makeAI()
{

  %aiCount = countRedAI();
  %humanCount = countLivePlayers ();


  if ( %aiCount >= %humanCount + $moreai ) return;

   %herc = getRandomAI();
   %herc.hits = 0;
   SetPilotId(%herc, $currentPilot);
   setTeam (%herc, *IDSTR_TEAM_RED);
   addToSet( "MissionGroup/redHercs", %herc );

//$hercDropPoint = getNextDropPoint();

//%x = getPosition($hercDropPoint,x);
//%y = getPosition($hercDropPoint,y);
//%z = getPosition($hercDropPoint,z);

 //setPosition (%herc, %x, %y, %z);

  redrop (%herc);

  order (%herc, Guard, $hercPath );
  order (%herc, speed, high);
}

function teamsetzen()
{
   $herc.hits = 0;

   SetPilotId( $herc, $currentPilot);
   setTeam ($herc, *IDSTR_TEAM_RED);
   addToSet( "MissionGroup/redHercs", $herc );
   redrop($herc);
   order($herc,guard,$hercPath);
}

function vehicle::onAttacked( %this, %attacker )
{

   // see if it is a player
   %player = playerManager::vehicleIdToPlayerNum (%attacker);
   if(%player == 0) 
      return;

%this.hits++;

// say (%player, 0, "Hit enemy "@ %this.hits);
}


function selector::structure::onAttacked( %this, %attacker )
{

  if ( $aiMade == false )
   {
     $aiMade = true;
     schedule ("makeAI();", 5);
   }


}

function selector::structure::onScan( %this, %attacker )
{

say (0,0,"selector scanned");

}


//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == False))
       {
         %count++;
       }
     }
  return %count;

}

function countRedAI()
{
  %count = 0;

  %thisHerc = getNextObject ($redHercGroup, 0);

  while (%thisHerc != 0)
   {

     %count = %count + 1;

     %thisHerc = getNextObject ($redHercGroup, %thisHerc);

   }
  return %count;
}

