// FILENAME:	TDM_Collesseum.cs
//
// AUTHORS:  	Ditto
//------------------------------------------------------------------------------

$missionName = "TDM_Colosseum";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	marsSounds();
}

function onMissionLoad(){
   cdAudioCycle("Yougot", "Cyberntx", "Xolox"); 
}
function player::onAdd(%this)
{
   say(%this, 0, "Welcome to The Colosseum. This map was made by [GoP] Ditto. Please visit us on the web at: www.gopstarsiege.cjb.net.");
}

function vehicle::onAdd(%vehicleId)
{
%vehicleId.name = getHUDName(%vehicleId);
}

function turret::onAdd(%this)
{
	if($server::TeamPlay == false)
	{
		setTeam(%this, *IDSTR_TEAM_BLUE);
	}
}

// Transporter Functionality
// --------------------------------------------------------------------------
function YellowTransporter::trigger::onEnter(%this, %vehicleId){
	%teamName = getTeam(%vehicleId);
	
	if(%teamName == *IDSTR_TEAM_RED){
			transportToRedBase(%vehicleId);
	}
	else if(%teamName == *IDSTR_TEAM_BLUE){
			transportToBlueBase(%vehicleId);
	}
	
   

}
function BlueTransporter::trigger::onEnter(%this, %vehicleId){
			transportToArena(%vehicleId);

}
function RedTransporter::trigger::onEnter(%this, %vehicleId){
			transportToArena(%vehicleId);
}


function transportToBlueBase(%vehicleId)
{
	echo("Transporting to Blue Base");
	randomTransport(%vehicleId, -650, -950, 500);
}

function transportToRedBase(%vehicleId)
{
	echo("Transporting to Red Base");
	randomTransport(%vehicleId,  965, 842, 750);
}

function transportToArena(%vehicleId)
{
      randomTransport(%vehicleId, 99, -75, -11, 87);
}











