// FILENAME: Server_TDM_CityMaps.cs
//
//Team Deathmatch Server


exec(serverLocation);
$pref::chatCensor = "true";
//-------------------------------------------------
//  RC file to start a server automatically
//-------------------------------------------------

//-------------------------------------------------
// Edit the parameters of this file to configure
// your server options. Use notepad, not a word
// processor. File must be saved as text only.
//-------------------------------------------------

//-------------------------------------------------
// Type the name for your server inside the quotes
// Must be less then 22 characters
//-------------------------------------------------
$server::Hostname =   "DSK: 33 Campaigns!";
// $server::wonnet = true;

//-------------------------------------------------
// Password Protection. Leave blank for none.
// Quotes optional.
//-------------------------------------------------
$server::Password =         "";

//-------------------------------------------------
// Maximum player limit. 16 is highest recommended.
//-------------------------------------------------
$server::MaxPlayers =                     16;

//-------------------------------------------------
// Number of kills before server cycles.
// If zero, kills are never reset.
//-------------------------------------------------
$server::FragLimit =                               0;

//-------------------------------------------------
// Time limit in minutes before server cycles.
// Must be a positive integer.
//-------------------------------------------------
$server::TimeLimit =                               0;

//-------------------------------------------------
// Mass limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::MassLimit =                               0;

//-------------------------------------------------
// Combat Value limit per player
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::CombatValueLimit =                         0;

//-------------------------------------------------
// Team play options. TeamPlay false =  deathmatch.
// TeamPlay true = teams
//-------------------------------------------------
$server::TeamPlay =                                true;

// TeamDamage = false: Kein Schaden bei Beschu durch Teamkollegen
$server::TeamDamage =                             false;

//-------------------------------------------------
// Team Mass limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamMassLimit =                            0;

//-------------------------------------------------
// Team Combat Value Limit - valid only when teamPlay is true
// Must be a positive integer or zero for no limit.
//-------------------------------------------------
$server::TeamCombatValueLimit =                     0;

//-------------------------------------------------
// Tech Level Limit
// Must be a positive integer less then or
// equal to 128 or zero for no limit.
//-------------------------------------------------
$server::TechLevelLimit =                          0;

//-------------------------------------------------
// Drop In Progress
// Does server allow drop in progress??
//-------------------------------------------------
$server::DropInProgress =                            TRUE  ;

$server::AllowMixedTech =                            TRUE  ;
$server::FactoryVehOnly =                           FALSE  ;
$server::AllowTeamRed =                              FALSE  ;
$server::AllowTeamYellow =                          TRUE  ;
$server::AllowTeamBlue =                             TRUE  ;
$server::AllowTeamPurple =                          FALSE ;

//-------------------------------------------------
// Mission rotation list. This is the order the
// worlds will cycle in a game with either the frag
// or time limits set.
//-------------------------------------------------
$MissionCycling::Stage0 =        "c_Destroy_Flyer";
$MissionCycling::Stage1 =        "c_Assasination";
$MissionCycling::Stage2 =        "c_Rescue";
$MissionCycling::Stage3 =        "c_moonpatrol";
$MissionCycling::Stage4 =        "c_DefendSaThauri";
$MissionCycling::Stage5 =        "c_cybridassault";
$MissionCycling::Stage6 =        "c_Fear_no_evil";

$MissionCycling::Stage7 =        "c_MIB_Martian_Recon"; // mib campaigns
$MissionCycling::Stage8 =        "c_MIB_Covert_Strike";
$MissionCycling::Stage9 =        "c_MIB_Rescue_Technician";
$MissionCycling::Stage10 =        "c_MIB_New_Technology";
$MissionCycling::Stage11 =        "c_MIB_Arctic_Infiltration";
$MissionCycling::Stage12 =        "c_MIB_Defend_Alexandria";

$MissionCycling::Stage13 =        "c_CybridBeachHead";
$MissionCycling::Stage14 =        "c_Escort_Duty";
$MissionCycling::Stage15 =        "c_FiRe_Origins";
$MissionCycling::Stage16 =        "c_Pirate_Hunt";

$MissionCycling::Stage17 =        "c_Arctic_Survey";
$MissionCycling::Stage18 =        "c_Beau Geste";
$MissionCycling::Stage19 =        "c_Boot Camp";
$MissionCycling::Stage20 =        "c_Boris&Natasha";
$MissionCycling::Stage21 =        "c_CM_RedWhirlwind";
$MissionCycling::Stage22 =        "c_CrashLand";
$MissionCycling::Stage23 =        "c_Invasion";
$MissionCycling::Stage24 =        "c_Long Patrol";
$MissionCycling::Stage25 =        "c_Missle Strike";
$MissionCycling::Stage26 =        "c_Prometheus";
$MissionCycling::Stage27 =        "c_Rebel Stronghold";
$MissionCycling::Stage28 =        "c_SaltRiverCanyon";
$MissionCycling::Stage29 =        "c_ScrapHeap";
$MissionCycling::Stage30 =        "c_Urban Assault";
$MissionCycling::Stage31 =        "c_WarFactory";
$MissionCycling::Stage32 =        "c_Will_The_Real_Prommie";

//-------------------------------------------------
// Start mission. Defines which mission from the
// rotation list the server starts on.
//-------------------------------------------------

%m=randomInt(0,32);
if (%m==0) {$server::Mission =         $MissionCycling::Stage0;}
if (%m==1) {$server::Mission =         $MissionCycling::Stage1;}
if (%m==2) {$server::Mission =         $MissionCycling::Stage2;}
if (%m==3) {$server::Mission =         $MissionCycling::Stage3;}
if (%m==4) {$server::Mission =         $MissionCycling::Stage4;}
if (%m==5) {$server::Mission =         $MissionCycling::Stage5;}
if (%m==6) {$server::Mission =         $MissionCycling::Stage6;}
if (%m==7) {$server::Mission =         $MissionCycling::Stage7;}
if (%m==8) {$server::Mission =         $MissionCycling::Stage8;}
if (%m==9) {$server::Mission =         $MissionCycling::Stage9;}
if (%m==10) {$server::Mission =         $MissionCycling::Stage10;}
if (%m==11) {$server::Mission =         $MissionCycling::Stage11;}
if (%m==12) {$server::Mission =         $MissionCycling::Stage12;}
if (%m==13) {$server::Mission =         $MissionCycling::Stage13;}
if (%m==14) {$server::Mission =         $MissionCycling::Stage14;}
if (%m==15) {$server::Mission =         $MissionCycling::Stage15;}
if (%m==16) {$server::Mission =         $MissionCycling::Stage16;}
if (%m==17) {$server::Mission =         $MissionCycling::Stage17;}
if (%m==18) {$server::Mission =         $MissionCycling::Stage18;}
if (%m==19) {$server::Mission =         $MissionCycling::Stage19;}
if (%m==20) {$server::Mission =         $MissionCycling::Stage20;}
if (%m==21) {$server::Mission =         $MissionCycling::Stage21;}
if (%m==22) {$server::Mission =         $MissionCycling::Stage22;}
if (%m==23) {$server::Mission =         $MissionCycling::Stage23;}
if (%m==24) {$server::Mission =         $MissionCycling::Stage24;}
if (%m==25) {$server::Mission =         $MissionCycling::Stage25;}
if (%m==26) {$server::Mission =         $MissionCycling::Stage26;}
if (%m==27) {$server::Mission =         $MissionCycling::Stage27;}
if (%m==28) {$server::Mission =         $MissionCycling::Stage28;}
if (%m==29) {$server::Mission =         $MissionCycling::Stage29;}
if (%m==30) {$server::Mission =         $MissionCycling::Stage30;}
if (%m==31) {$server::Mission =         $MissionCycling::Stage31;}
if (%m==32) {$server::Mission =         $MissionCycling::Stage32;}
if (%m==33) {$server::Mission =         $MissionCycling::Stage33;}

// These items will be allowed by default -- your mission script can change these
// by calling allowVehicle, allowComponent, or allowWeapon
function setAllowedItems()
{
   allowvehicle(all,true);
   allowvehicle(29,true);
}

