
//----  script file, SaltRiverCanyon
//===========================================

// AUTHORS:  	Slade & Filthy Clyde
// Code stolen happily from Dolf Kooz Maps and mike the goad.
// Version 1.08c

console::enable(true);

$OVconvoyTech = 1;

$server::TeamDamage = true;

$actionStarted = false;

$maxRange = 3200;
$minRange = 1500;

// how many player are alive at squad drop time
$numLivePlayers = 0;

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------
   
Pilot backupPilot
{
   id = 29;
   
   skill = 0.5;
   accuracy = 0.4;
   aggressiveness = 0.8;
   activateDist = 11000.0;
   deactivateBuff = 12000.0;
   targetFreq = 5.4;
   trackFreq = 2.0;
   fireFreq = 2.0;
   LOSFreq = 0.1;
   orderFreq = 0.2;
};
   

function onMissionLoad()
{


   cdAudioCycle("Purge", "Watching", "Mechsoul"); 

    $textMsg = "Mission Credits:  Slade & Filthy Clyde.  "@
      "Objectives:  Find the Scientists, Get them and the Technology, "@
      "Extraction at Nav Delta.  "@
   "Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";
   %history = 
"\n\nDate: 2832. Listen up guys.  Scientists found a cave in an Anasazi Cliff Dwelling "@
"in the Salt River Canyon in New Mexico.  There is some kind of Alien Weapons Booster in it."@
" They called us by uncoded radio.  The Cybrids intercepted the transmission.  They are under"@
" attack.  Link up with your squad, protect the Scientists, grab whatever it is with your Tractor Beam, and get out."@
"  There should be a landing pad the Dropship can use at the site, if the Pilot can find it."@
"  Good luck.";



   setGameInfo ($textMsg @ %history);
}


//--------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);

   marsSounds();
   windSounds();
   init();

}

//---------------------------------------------
function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");

}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

 messagebox (%player, "Check the game info tab for game details");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }


//---------------------------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);
              Say(%player,0,"<F5>TAC-COM HERE:  The Cliff Dwelling is SouthEast of you.  Move it!    ");

       }
   }

}

//-----------------Use to rotate Navpoints---------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
   createbackup();
//   createbackup();
//   createbackup();
}
//-------------------------------------------------------------------------
function setNavCharlieON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, true, %playerVeh  );
     }
   checkCrateArrive();
   createbackup();
//   createbackup();
//   createbackup();
}
//-------------------------------------------------------------------------
function setNavDeltaON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navDelta, true, %playerVeh  );
     }
   createbackup();
   createbackup();
//   createbackup();
}
//-------------------------------------------------------------------------
function setNavEchoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navEcho, true, %playerVeh  );
     }
   createbackup();
   createbackup();
//   createbackup();

}


//-----------------------HEYBABY LOGIC-----------------------------------------
//-----------------(as in Heybaby, I'm home)-----------------------------------
//-----------------------------------------------------------------------------
function checkCrateArrive()
{
  %var = getDistance( $Crate, $navEcho );
 
  if ( %var < 240 )
   {
    $objective3 = true;
    say (0,0, "<f5>Weapons Booster Crate is at Dropship.");
    say (0,0, "<f5>Objective 3 complete.");
    createbackup();
//    createbackup();
//    createbackup();
   schedule( "winCondition();", 480 ); 
   }
   else
    {
      schedule ("checkCrateArrive();", 10 );
    }
}


//-----------------------------------------------------------------------------
function init()
{

$objective1 = false;
$objective2 = false;
$objective3 = false;



   $attackStarted = false;



$buildingsDestroyed = 0;
$Crate = "MissionGroup/Crate";
$navAlpha = "MissionGroup/navPoints/navAlpha";
$navBravo = "MissionGroup/navPoints/navBravo";
$navCharlie = "MissionGroup/navPoints/navCharlie";
$navDelta = "MissionGroup/navPoints/navDelta";
$navEcho = "MissionGroup/navPoints/navEcho";
   MPcheckBoundary( leave, getObjectID ($navAlpha) , 250, onLeaveNavAlphaWarning, 1 );




}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onLeaveNavAlphaWarning ()
{

   $actionStarted = true;
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
   say (0,0, "<f5>TAC-COM here:  The Scientists are under attack, Head SouthEast for the canyon.  Go to all Nav Points, complete all 3 objectives.");
   $attackStarted = true;
   createbackup();
//   createbackup();
//   createbackup();
   setNavBravoON();
   MPcheckBoundary( enter, getObjectID ($navBravo) , 50, onArriveNavBravo, 2 );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onArriveNavBravo()
{
   say (0,0, "<f5>TAC-COM here:  Objective 1 completed - you found the right place.");
   say (0,0, "<f5>TAC-COM here:  The Scientists are hiding here somewhere.  Maybe in the cave.  Find them.");
   setNavCharlieON();
   MPcheckBoundary( enter, getObjectID ($navCharlie) , 100, onArriveNavCharlie, 2 );
   $objective1 = true;
}
//-----------------------------------------------------------------------------
function onArriveNavCharlie()
{
   say (0,0, "<f5>TAC-COM here:  Objective 2 completed.  Load the scientists in your hercs.");
   say (0,0, "<f5>TAC-COM here:  Find the Crate with the Weapons Booster and bring it to the DS with your Tractor Beam.");
   setNavDeltaON();
   MPcheckBoundary( enter, getObjectID ($navDelta) , 150, onArriveNavDelta, 2 );
   createDropShip();//at navEcho
   $objective2 = true;
   schedule( "say(0, 0, \"<F5>Scientists:  Thank god you people got here.  We've been hiding for weeks.  Now if we can just squeeze into your hercs.\");", 1 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot here:  Here at Nav Delta and ready for pickup.\");", 10 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot:  Ummm... Sir... We aren't at Nav Delta.  I think we're at Nav Echo....\");", 45 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot:  Look buddy, I was told to find the landing pad.  We're here on the pad, there's the cliff house, so what is your problem?\");", 50 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot:  Wrong pad, Sir......\");", 55 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot:  So those guys get to walk a little....  So what?  Wake me up when they get here.  I'll be in my cabin.  \");", 88 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP CoPilot:  Ummm... Sir...?  Are you taking that case of beer with you?  I thought that was for the squad.... \");", 100 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot :  I'm here, they're not, and what they don't know won't hurt em....  Take care of things while I'm gone..... \");", 110 );     
   schedule( "say(0, 0, \"<F5>DROPSHIP Pilot :   Hey, guess what??  Beer is good....  Bwahahahaha.....\");", 150 );     
    
       MPcheckBoundary( enter, getObjectID ($navEcho) , 140, onArriveNavEcho, 20 );
}
//-----------------------------------------------------------------------------
function onArriveNavDelta()
{
   say (0,0, "<f5>TAC-COM here:  Looks like the Dropship is at Nav Echo.  Better get over there.");
   say (0,0, "<f5>TAC-COM here:  Don't forget to bring the Weapons Booster.");
   setNavEchoON();
   schedule( "winCondition();", 1320 ); 
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------


function onArriveNavEcho()
{

 %obj1 = getObjectID ( $navEcho );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavEcho();", 10 );
    }

}



//-----------------------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{


}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }




  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   // healobject ( %who, 5000 );
   // healobject ( %who, 5000 );
   // healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }

}
//-----------------allow DS to heal--------------------------------------------
function vehicle::onAttacked ( %this, %who )
{
//   if (%this == getObjectId( "$hercD" ) )
     if (%this ==  $hercD )
     {
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
     }
}


//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %nums = 0;

  if ( $objective1 == true )
    {
     %nums++;
    }
  if ( $objective2 == true )
    {
     %nums++;
    }
  if ( $objective3 == true )
    {
     %nums++;
    }


  if ( %nums == 3 )
    {
     %text = "Weapons Booster recovered and Scientists Rescued.  Excellent work team.";
    }

  if ( %nums < 3 )
    {
     %text = "Mission Failed.  Wow, Life is gonna get messy, now..... ";
    }
  
  messageBox(0, "Mission Over, " @ %nums @ " of 3 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navDelta);
  deleteVariables($navEcho);
  deleteVariables($Crate);
  deleteVariables($tm);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($hercD);

  // $MissionCycling::Stage0 = "c_warfactory";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($navDelta);
  deleteVariables($navEcho);
  deleteVariables($Crate);
  deleteVariables($tm);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($hercD);

  // $MissionCycling::Stage0 = "c_warfactory";
  // $server::Mission = $MissionCycling::Stage0;
  
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}


//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function createDropShip()
{
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,28);

  addToSet( $cargogroup, $hercD );

  setPosition ($hercD, -587.00, 6582.00, 110.00 );

// don't let that ship take off!
   order( $hercD, shutdown, True );
}

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

// have the enemy pick a new target
// attacker can run into buildings
  %who1 = playerManager::vehicleIdToPlayerNum (%this);
  if ( %who1 != 0 ) return;

   %target = pickPlayer ();

   order (%this, attack, %target);
}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 40, %rot);

}

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;

//	if (%t == 1) return "C";
//	if (%t == 2) return "H";
	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{

 $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navAlpha), 4, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 6 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 8 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 10 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 12 );
     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 14 );
     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 16 );
     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 18 );
}

function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{
 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 50 ;
      %y = %y + 50 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);

//      if ( RandomInt (1,2) == 1 )
//        {
          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );
//        }
//      else
//        {
//          order ( %thisGroup, guard, $retreatPath );
//        }
    }

//    order (%leadherc, makeleader, true);
//    order ( %thisGroup, formation, Delta );

}




//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particular reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}
//-------------------------TRANSPORTER--------------------
function ZenTransporter2::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
   healobject ( %object, 5000 );
   healobject ( %object, 5000 );
   healobject ( %object, 5000 );

  reloadObject(%object, 5000 );
  reloadObject(%object, 5000 );
	setPosition(%object, 3268, -4853, 227);
}
//---------------------------------------------------------------
//---------------TRACTOR BEAM STUFF FROM "MOVE IT"---------------
//------------------Thank you, mike the goad---------------------
function Crate::structure::onScan(%this,%scanner)	
{
if($tm == "")
 {
 $tm = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt();
 }
 else
 {
 $tm = "";
 }
}

function mt()
{
%x = getPosition($tm,x);
%y = (getPosition($tm,y) - 50);
%z = getPosition($tm,z);
if(%x == %z)					// he died or left
 {
 $tm = "";
 pt();
 }
 else
 {
   %z = %z + 5.0;
 setPosition("MissionGroup\\Crate",%x,%y,%z);

 }
if($tm != "")
 {
 schedule("mt();",0.2);
 }
 else
 {
 pt();
 }
}

function pt()
{
%x = getPosition("MissionGroup\\Crate",x);
%y = getPosition("MissionGroup\\Crate",y);
%z = (getTerrainHeight(%x,%y) + 5.0);
setPosition("MissionGroup\\Crate",%x,%y,%z);
}
//---------------------------------------------------------------
//---------------------------------------------------------------